# PrivateStorageMobile

[https://whetstone.private.storage/privatestorage/privatestoragemobile/-/commits/main](https://whetstone.private.storage/privatestorage/privatestoragemobile/badges/main/pipeline.svg)

## Description

This is the Android application for the PrivateStorage service.
Its first user-facing milestone is to provide a read-only view of data managed from the desktop client.

## Overall plan

See [this document on the next steps](Overall Plan.rst) until we have tickets and better visibility on who's working on what, what's completed, and what's blocking.

## Project status

This application is in the early stages of development.
See the issue tracker and the overall plan document for detailed status information.

## Build

Build an Android apk and install it to an Android device connected via USB
(with necessary permissions granted):

```sh
nix-build -A android.frontend -o result-android-frontend
./result-android-frontend/bin/deploy
```

## Update Dependencies

### nix-thunk

Some dependencies are managed using [nix-thunk](https://github.com/obsidiansystems/nix-thunk).
These can be found in ``obelisk/dep``.

Nix thunks are essentially references to git repositories.
These can be unpacked to their source in-place when working on the project or packed up into a few small files.

To work with nix thunks first install the ``nix-thunk`` tool.

Consider an example dependency "botan".
From the top-level of this repo,
to clone a copy of the Botan git repository at the appropriate commit, run:

```sh
nix-thunk unpack obelisk/dep/botan
```

You can work on it in-place and when you are done, pack it up again:

```sh
nix-thunk pack obelisk/dep/botan
```

This requires that changes have been committed and pushed.

Note:
A bug in the current version of Obelisk (link?) causes trouble if certain repos are unpacked.
If you have any trouble running an ``ob`` command (ob run, ob repl, etc.) with a thunk unpacked,
try adding the flag ``--no-interpret obelisk/dep`` and hopefully that will sort it out.
