-- | Implement platform-specific path-related operations for the Android
-- platform.
module FrontendPaths (getFilesDir) where

import qualified Android.HaskellActivity as Android

-- | Get the path to a directory that is private to the application where
-- internal application data may be written (and read back).
--
-- The application requires no special permissions to use this directory.  If
-- the app is uninstalled the directory and its children will be deleted.
--
-- https://developer.android.com/reference/android/content/Context#getFilesDir()
getFilesDir :: IO (Maybe FilePath)
getFilesDir = Android.getHaskellActivity >>= Android.getFilesDir
