{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE TemplateHaskell #-}
{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE TypeFamilies #-}
{-# LANGUAGE ScopedTypeVariables #-}

module Frontend where

import Obelisk.Frontend
import Obelisk.Route
import Obelisk.Generated.Static
import Reflex.Dom.Core

import Common.Route

import Controller (activePage)

-- This runs in a monad that can be run on the client or the server.
-- To run code in a pure client or pure server context, use one of the
-- `prerender` functions.
frontend :: Frontend (R FrontendRoute)
frontend = Frontend
  { _frontend_head = do
      el "title" $ text "Tahoe-LAFS Mobile"

      -- Include external Material 2 assets as per the tutorial at
      -- https://m2.material.io/develop/web/getting-started
      elAttr "link" ("href" =: "https://unpkg.com/material-components-web@latest/dist/material-components-web.min.css" <> "rel" =: "stylesheet") blank
      elAttr "link" ("href" =: "https://fonts.googleapis.com/icon?family=Material+Icons" <> "rel" =: "stylesheet") blank
      elAttr "link" ("href" =: "https://fonts.googleapis.com/css?family=Roboto:300,400,500" <> "rel" =: "stylesheet") blank
      elAttr "script" ("src" =: "https://unpkg.com/material-components-web@latest/dist/material-components-web.min.js") blank
      elAttr "link" ("href" =: $(static "main.css") <> "type" =: "text/css" <> "rel" =: "stylesheet") blank

  -- Obelisk.Route.Frontend.RoutedT t (R FrontendRoute) m ()
  , _frontend_body = activePage
  }
