{ pkgs, nix-thunk }:
self: super:
with pkgs.haskell.lib; {
  # Here, we get the tahoe-chk package from its thunk and use callCabal2nix to
  # get a nix derivation to build it.
  tahoe-chk = self.callCabal2nix "tahoe-chk" (nix-thunk.thunkSource ./dep/tahoe-chk) {};

  # We also ended up needing an override of the base32 library, which we obtain from Hackage.
  base32 = self.callHackageDirect {
    pkg = "base32";
    ver = "0.2.1.0";
    sha256 = "04glpmwp50qi29h8cb5j0w1rz0ww30nw4xgj2a3l7zh1gprhwj89";
  } {};

  # A handy library for generating Android Material Design styled GUIs.
  reflex-material = self.callCabal2nix "reflex-material" (nix-thunk.thunkSource ./dep/reflex-material + "/reflex-material") {};
}
